## deepin-calculator 5.6.0.10

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9.5)

if (NOT DEFINED VERSION)
    set(VERSION 1.2.2)
endif ()

#最外层一个工程，单项目中不添加工程，只添加执行文件
project(deepin-calculator)

#源码程序目录
add_subdirectory(src)

#开关默认UT测试关闭
#QT左侧栏项目中找到USE_TEST键值，点击打开即可测试
#若无法点击开关，尝试工具-选项-环境-Theme切换至dark
option(USE_TEST "UT" no)
if (USE_TEST)
add_subdirectory(tests)  #tests为ut测试文件夹名
endif(USE_TEST)

=== src/CMakeLists.txt ===
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-needed -fPIE")
set(QT_MINIMUM_VERSION "5.7.1")
set(CMAKE_EXE_LINKER_FLAGS "-pie")

add_definitions(-DQT_NO_DEBUG_OUTPUT)

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    message(STATUS "this system is mips64=========")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -Wl,--as-needed")
endif()

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")

    execute_process(COMMAND bash "${CMAKE_CURRENT_LIST_DIR}/../translate_generation.sh"
                    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/../)
endif ()

configure_file(environments.h.in environments.h @ONLY)

# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Xml REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5Test REQUIRED)

find_package(DtkWidget REQUIRED dtkwidget)
find_package(DtkGui REQUIRED dtkgui)
find_package(DtkCore REQUIRED dtkcore)
#find_package(DFrameworkDbus REQUIRED dframeworkdbus)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

include_directories(${DtkWidget_INCLUDE_DIRS})
include_directories(${DtkGui_INCLUDE_DIRS})
include_directories(${DtkCore_INCLUDE_DIRS})

set (EXE_NAME deepin-calculator)

set(LINK_LIBS
    Qt5::Core
    Qt5::DBus
    Qt5::Widgets
    Qt5::Xml
    Qt5::Svg
    Qt5::Test

    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
)

file(GLOB_RECURSE CAL_H ${CMAKE_CURRENT_LIST_DIR}/*.h)

file(GLOB_RECURSE CAL_C ${CMAKE_CURRENT_LIST_DIR}/*.c)

file(GLOB_RECURSE CAL_CPP ${CMAKE_CURRENT_LIST_DIR}/*.cpp)

set (DC_QRC_FILES
    deepin-calculator.qrc
)

add_executable (${EXE_NAME}
    ${CAL_H}
    ${CAL_C}
    ${CAL_CPP}
    ${DC_QRC_FILES}
)

target_include_directories(${EXE_NAME} PUBLIC ${Qt5Widgets_LIBRARIES}
                                              ${Qt5DBus_LIBRARIES}
                                              ${Qt5TestLib_LIBRARIES}
                                              ${PROJECT_BINARY_DIR}
                                              ${DtkWidget_INCLUDE_DIRS}
                                              ${DtkCore_LIBRARIES}
                                              ${DtkGUI_INCLUDE_DIRS}
                                              ${DFrameworkDBus_INCLUDE_DIRS})

target_link_libraries (${EXE_NAME} ${LINK_LIBS})

set(CMAKE_INSTALL_PREFIX /usr)

install(TARGETS deepin-calculator DESTINATION bin)
file(GLOB QM_FILES "${CMAKE_CURRENT_LIST_DIR}/../translations/*.qm")
install(FILES ${QM_FILES} DESTINATION share/deepin-calculator/translations)
install(FILES ${CMAKE_CURRENT_LIST_DIR}/../deepin-calculator.desktop
        DESTINATION share/applications/)
install(FILES assets/images/deepin-calculator.svg
            DESTINATION share/icons/hicolor/scalable/apps/)

=== tests/CMakeLists.txt ===
#源程序cmakelists再添加上ut相关环境搭建
#ut相关环境搭建详情见
#https://wikidev.uniontech.com/index.php?title=UT_%E6%B5%8B%E8%AF%95%E7%8E%AF%E5%A2%83%E6%90%AD%E5%BB%BA#.E7.94.A8.E4.BE.8B.E7.BC.96.E5.86.99_.7C_UT_Case

cmake_minimum_required(VERSION 3.9.5)

if (NOT DEFINED VERSION)
    set(VERSION 1.2.2)
endif ()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-needed -fPIE")
set(QT_MINIMUM_VERSION "5.7.1")
set(CMAKE_EXE_LINKER_FLAGS "-pie")

add_definitions(-DQT_NO_DEBUG_OUTPUT)

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    message(STATUS "this system is mips64=========")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -Wl,--as-needed")
endif()

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")

    execute_process(COMMAND bash "${CMAKE_CURRENT_LIST_DIR}/../translate_generation.sh"
                    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/../)
endif ()

configure_file(${CMAKE_CURRENT_LIST_DIR}/../src/environments.h.in environments.h @ONLY)

# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Xml REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5Test REQUIRED)

find_package(DtkWidget REQUIRED dtkwidget)
find_package(DtkGui REQUIRED dtkgui)
find_package(DtkCore REQUIRED dtkcore)
#find_package(DFrameworkDbus REQUIRED dframeworkdbus)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

include_directories(${DtkWidget_INCLUDE_DIRS})
include_directories(${DtkGui_INCLUDE_DIRS})
include_directories(${DtkCore_INCLUDE_DIRS})

set (EXE_NAME deepin-calculator)

set(LINK_LIBS
    Qt5::Core
    Qt5::DBus
    Qt5::Widgets
    Qt5::Xml
    Qt5::Svg
    Qt5::Test

    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
)

#CMAKE_CURRENT_LIST_DIR缓存文件的目录，头文件找不到问题解决方案1,文件中未使用该头文件变量　2,CMAKE_CURRENT_LIST_DIR改为CMAKE_SOURCE_DIR
SET(HEAD ${CMAKE_CURRENT_LIST_DIR}/../src
         ${CMAKE_CURRENT_LIST_DIR}/../src/bak
         ${CMAKE_CURRENT_LIST_DIR}/../src/control
         ${CMAKE_CURRENT_LIST_DIR}/../src/core
         ${CMAKE_CURRENT_LIST_DIR}/../src/math
         ${CMAKE_CURRENT_LIST_DIR}/../src/views
         ${CMAKE_CURRENT_LIST_DIR}/../src/widgets
         )

file(GLOB_RECURSE CAL_H ${CMAKE_CURRENT_LIST_DIR}/../src/*.h)

file(GLOB_RECURSE CAL_C ${CMAKE_CURRENT_LIST_DIR}/../src/*.c)

file(GLOB_RECURSE CAL_CPP ${CMAKE_CURRENT_LIST_DIR}/../src/*.cpp)
list(REMOVE_ITEM CAL_CPP "${CMAKE_CURRENT_LIST_DIR}/../src/main.cpp")
file(GLOB_RECURSE CAL_TEST ${CMAKE_CURRENT_LIST_DIR}/src/*.cpp)
file(GLOB_RECURSE CAL_TESTH ${CMAKE_CURRENT_LIST_DIR}/src/*.h)
include_directories(third_party)                           #一下三行添加包含以便测试用例代码的编写
include_directories(third_party/googlemock/include)
include_directories(third_party/googletest/include)
add_subdirectory(third_party)                              #添加googletest库

set (DC_QRC_FILES
    ${CMAKE_CURRENT_LIST_DIR}/../src/deepin-calculator.qrc
)

set(PROJECT_NAME_TEST
    ${PROJECT_NAME}_test)

# 生成测试可执行程序
add_executable(${PROJECT_NAME_TEST} ${CAL_H} ${CAL_C} ${CAL_CPP} ${CAL_TEST} ${CAL_TESTH})

# 生成测试可执行程序的依赖库
target_link_libraries(${PROJECT_NAME_TEST} gmock gmock_main gtest gtest_main)

target_include_directories(${PROJECT_NAME_TEST} PUBLIC ${Qt5Widgets_LIBRARIES}
                                              ${Qt5DBus_LIBRARIES}
                                              ${Qt5TestLib_LIBRARIES}
                                              ${PROJECT_BINARY_DIR}
                                              ${DtkWidget_INCLUDE_DIRS}
                                              ${DtkCore_LIBRARIES}
                                              ${DtkGUI_INCLUDE_DIRS}
                                              ${DFrameworkDBus_INCLUDE_DIRS}
                                              ${HEAD})
target_link_libraries (${PROJECT_NAME_TEST} ${LINK_LIBS})

set(CMAKE_INSTALL_PREFIX /usr)

install(TARGETS deepin-calculator DESTINATION bin)
file(GLOB QM_FILES "${CMAKE_CURRENT_LIST_DIR}/../translations/*.qm")
install(FILES ${QM_FILES} DESTINATION share/deepin-calculator/translations)
install(FILES ${CMAKE_CURRENT_LIST_DIR}/../deepin-calculator.desktop
        DESTINATION share/applications/)
install(FILES ${CMAKE_CURRENT_LIST_DIR}/../src/assets/images/deepin-calculator.svg
            DESTINATION share/icons/hicolor/scalable/apps/)

#------------------------------ 创建'make test'指令---------------------------------------
add_custom_target(test
    COMMAND mkdir -p tests/coverageResult
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

add_custom_command(TARGET test
    COMMAND echo " =================== CREAT LCOV REPROT BEGIN ==================== "

    #1.清理原先的gcov信息
    COMMAND lcov --directory ./tests/CMakeFiles/${PROJECT_NAME_TEST}.dir --zerocounters
    COMMAND lcov --directory ./tests/CMakeFiles/${PROJECT_NAME}.dir --zerocounters
    COMMAND ./tests/${PROJECT_NAME_TEST}

    #2.收集gcov信息到.info文件中
    COMMAND lcov --directory . --capture --output-file ./tests/coverageResult/${PROJECT_NAME}_Coverage.info

    #3.过滤一些我们不感兴趣的文件的覆盖率信息
    COMMAND echo " =================== do filter begin ==================== "
    COMMAND lcov --remove ./tests/coverageResult/${PROJECT_NAME}_Coverage.info
    '*/${PROJECT_NAME_TEST}_autogen/*' '*/${PROJECT_NAME}_autogen/*' '*/tests/*' '*/googletest/*' '*/usr/include/*' '*/src/bak/*' '*/src/core/*' '*/src/math/*'
    -o ./tests/coverageResult/${PROJECT_NAME}_Coverage.info
    COMMAND echo " =================== do filter end ==================== "

    #3.将.info信息生成报告到reprot文件夹中
    COMMAND genhtml -o ./tests/coverageResult/report ./tests/coverageResult/${PROJECT_NAME}_Coverage.info

    COMMAND echo " =================== CREAT LCOV REPROT END ==================== "

    COMMAND echo " Coverage files have been output to ${CMAKE_BINARY_DIR}/coverageResult/report "

    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )

#'make test'命令依赖与我们的测试程序
add_dependencies(test ${PROJECT_NAME_TEST})

# 设置添加gocv相关信息的输出
set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")

## deepin-calculator 1.0.2

=== debian/changelog ===
deepin-calculator (1.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches, applied upstream.
  * d/rules: Use /usr/share/dpkg/pkg-info.mk instead of dpkg-parsechangelog.
  * d/rules: Add build dependency qttools5-dev-tools.
  * d/control: Use Salsa platform for Vcs field.
  * d/control: Update Standers-Version to 4.1.3.
  * d/compat: Swithch compat to level 11.
  * d/copyright: Use https for copyright-format-uri.
  * d/copyright: Add missing GPL2 license-paragraph.

 -- Yanhao Mo <yanhaocs@gmail.com>  Fri, 30 Mar 2018 12:50:46 +0800

deepin-calculator (1.0.1-1) unstable; urgency=medium

  * Initial release (Closes: #883748)

 -- Yangfl <mmyangfl@gmail.com>  Thu, 07 Dec 2017 14:42:27 +0800

=== debian/control ===
Source: deepin-calculator
Section: math
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Yangfl <mmyangfl@gmail.com>,
 Yanhao Mo <yanhaocs@gmail.com>
Build-Depends:
 debhelper (>= 11),
 pkg-config,
 qt5-qmake,
 libdtkwidget-dev,
 libqt5svg5-dev,
 qttools5-dev-tools,
Standards-Version: 4.1.3
Homepage: https://github.com/linuxdeepin/deepin-calculator
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-calculator.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-calculator

Package: deepin-calculator
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Calculator for DDE (Deepin Desktop Environment)
 An easy to use calculator for ordinary users.
 .
 This package is part of DDE (Deepin Desktop Environment).

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1
include /usr/share/dpkg/pkg-info.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export QT_SELECT = 5

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- DEFINES+="VERSION=$(DEB_VERSION)"

## deepin-calculator 1.0.6

=== debian/changelog ===
deepin-calculator (1.0.6-1) unstable; urgency=medium

  * New upstream version 1.0.6.
  * debian/control: Bump Standards-Version to 4.2.1 (no changes needed).

 -- Boyuan Yang <073plan@gmail.com>  Sun, 26 Aug 2018 16:06:25 -0400

deepin-calculator (1.0.5-1) unstable; urgency=medium

  * New upstream version 1.0.5
  * Bump Standards-Version to 4.1.5 (no changes needed).

 -- Yanhao Mo <yanhaocs@gmail.com>  Fri, 03 Aug 2018 08:59:14 +0800

deepin-calculator (1.0.4-1) unstable; urgency=medium

  * New upstream version 1.0.4
    + Update translations.

 -- Yanhao Mo <yanhaocs@gmail.com>  Thu, 14 Jun 2018 08:56:23 +0800

deepin-calculator (1.0.3-1) unstable; urgency=medium

  * New upstream release.
  * d/contorl: Change maintainer field back to
    pkg-deepin-devel@lists.alioth.debian.org .

 -- Yanhao Mo <yanhaocs@gmail.com>  Thu, 17 May 2018 11:40:34 +0800

deepin-calculator (1.0.2-2) unstable; urgency=medium

  * Use team+pkg-deepin@tracker.debian.org in maintainer field.
  * Add myself into uploaders list.
  * debian: Apply "wrap-and-sort -abst".
  * Bump Standards-Version to 4.1.4 (no changes needed).
  * d/rules: Use "dh_missing --fail-missing".

 -- Boyuan Yang <073plan@gmail.com>  Thu, 19 Apr 2018 21:13:37 +0800

=== debian/control ===
Source: deepin-calculator
Section: math
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Yangfl <mmyangfl@gmail.com>,
 Yanhao Mo <yanhaocs@gmail.com>,
 Boyuan Yang <073plan@gmail.com>,
Build-Depends:
 debhelper (>= 11~),
 libdtkwidget-dev,
 libqt5svg5-dev,
 pkg-config,
 qt5-qmake,
 qttools5-dev-tools,
Standards-Version: 4.2.1
Homepage: https://github.com/linuxdeepin/deepin-calculator
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-calculator.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-calculator

Package: deepin-calculator
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Calculator for DDE (Deepin Desktop Environment)
 An easy to use calculator for ordinary users.
 .
 This package is part of DDE (Deepin Desktop Environment).

## deepin-calculator 1.0.7

=== debian/changelog ===
deepin-calculator (1.0.7-1) unstable; urgency=medium

  * New upstream version 1.0.7. 
  * debian/control: Update my uploader email address and use the
    @debian.org one.

 -- Boyuan Yang <byang@debian.org>  Thu, 18 Oct 2018 09:53:18 -0400

## deepin-calculator 1.0.9

=== debian/changelog ===
deepin-calculator (1.0.9-1) unstable; urgency=medium

  * New upstream version 1.0.9.

 -- Boyuan Yang <byang@debian.org>  Fri, 16 Nov 2018 13:18:00 -0500

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Yangfl <mmyangfl@gmail.com>,
  Yanhao Mo <yanhaocs@gmail.com>,
- Boyuan Yang <073plan@gmail.com>,
+ Boyuan Yang <byang@debian.org>,
 Build-Depends:
  debhelper (>= 11~),
  libdtkwidget-dev,

## deepin-calculator 1.0.10

=== debian/changelog ===
deepin-calculator (1.0.10-1) unstable; urgency=medium

  * New upstream version 1.0.10.
  * debian/control:
    + Build-depend on debhelper-compat (= 11) instead of using
      debian/compat file.
    + Use Rules-Requires-Root: no.

 -- Boyuan Yang <byang@debian.org>  Sun, 16 Dec 2018 23:44:23 -0500

=== debian/control ===
--- 
+++ 
@@ -7,12 +7,13 @@
  Yanhao Mo <yanhaocs@gmail.com>,
  Boyuan Yang <byang@debian.org>,
 Build-Depends:
- debhelper (>= 11~),
+ debhelper-compat (= 11),
  libdtkwidget-dev,
  libqt5svg5-dev,
  pkg-config,
  qt5-qmake,
  qttools5-dev-tools,
+Rules-Requires-Root: no
 Standards-Version: 4.2.1
 Homepage: https://github.com/linuxdeepin/deepin-calculator
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-calculator.git

## deepin-calculator 5.0.1

=== debian/changelog ===
deepin-calculator (5.0.1-2) unstable; urgency=medium

  * debian/patches:
    + Add build fix with dtk5.
    + Add patch for lintian desktop-entry-lacks-keywords-entry.
  * debian/control:
    + Add Arun Kumar Pariyar to uploaders list.
    + Bump debhelper compat to v13.
    + Bump Standards-Version to 4.5.1.
    + Tighten build dependency libdtkwidget-dev to (>=5.2~).
  * debian/upstream: Set upstream metadata fields Bug-Database,
    Bug-Submit, Repository, Repository-Browse.

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Sun, 06 Dec 2020 16:55:08 +0545

deepin-calculator (5.0.1-1) unstable; urgency=medium

  * New upstream release 5.0.1.
  * debian/control:
    + Bump Standards-Version to 4.4.1.
    + Bump debhelper compat to v12.

 -- Boyuan Yang <byang@debian.org>  Thu, 03 Oct 2019 15:05:28 -0400

=== debian/control ===
--- 
+++ 
@@ -6,15 +6,16 @@
  Yangfl <mmyangfl@gmail.com>,
  Yanhao Mo <yanhaocs@gmail.com>,
  Boyuan Yang <byang@debian.org>,
+ Arun Kumar Pariyar <openarungeek@gmail.com>,
 Build-Depends:
- debhelper-compat (= 11),
- libdtkwidget-dev,
+ debhelper-compat (= 13),
+ libdtkwidget-dev (>=5.2~),
  libqt5svg5-dev,
  pkg-config,
  qt5-qmake,
  qttools5-dev-tools,
 Rules-Requires-Root: no
-Standards-Version: 4.2.1
+Standards-Version: 4.5.1
 Homepage: https://github.com/linuxdeepin/deepin-calculator
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-calculator.git
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-calculator

## deepin-calculator 5.6.0.10

=== debian/changelog ===
deepin-calculator (5.6.0.10-2) unstable; urgency=medium

  * Source-only rebuild.
  * debian/control:
    + Add qinxialei to Uploaders.
  * debian/copyright:
    + Add License about tests/third_party/*.

 -- qinxialei <xialeiqin@gmail.com>  Sat, 30 Jan 2021 10:20:30 +0800

deepin-calculator (5.6.0.10-1) unstable; urgency=medium

  [Clay Stan]
  *New upstream release 5.6.0.10.
  [Tu Qinggang]
  *debian/control:
   + Add Tu Qinggang to Uploaders.
   + Add Clay Stan to Uploaders.
  *debian/patches:
   + Add 01-add-qt-header.patch for fix qtbase5.15 update.

 -- Clay Stan <claystan97@gmail.com>  Mon, 25 Jan 2021 14:05:58 +0800

deepin-calculator (5.5.17-1~exp1) experimental; urgency=medium

  * New upstream release 5.5.17.
  * debian/control:
    + Bump Standards-Version to 4.5.0.
    + Bump debhelper compat to v13.
    + Add libdtkgui-dev to Build-Depends.
    + Add Arun Kumar Pariyar to Uploaders.
  * debian/copyright:
    + Updated Files path.

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Tue, 23 Jun 2020 01:23:10 +0545

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,19 @@
  Yanhao Mo <yanhaocs@gmail.com>,
  Boyuan Yang <byang@debian.org>,
  Arun Kumar Pariyar <openarungeek@gmail.com>,
+ Tu Qinggang <tuqinggang@uniontech.com>,
+ Clay Stan <claystan97@gmail.com>,
+ qinxialei <xialeiqin@gmail.com>,
 Build-Depends:
+ cmake,
  debhelper-compat (= 13),
- libdtkwidget-dev (>=5.2~),
+ libdtkgui-dev,
+ libdtkwidget-dev,
  libqt5svg5-dev,
  pkg-config,
- qt5-qmake,
  qttools5-dev-tools,
+ qtbase5-dev,
+ libdframeworkdbus-dev,
 Rules-Requires-Root: no
 Standards-Version: 4.5.1
 Homepage: https://github.com/linuxdeepin/deepin-calculator

=== debian/rules ===
--- 
+++ 
@@ -13,10 +13,15 @@
 # package maintainers to append LDFLAGS
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
-export QT_SELECT = 5
+export QT_SELECT := 5
 
 %:
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- DEFINES+="VERSION=$(DEB_VERSION)"
+	dh_auto_configure -- \
+	  -DCMAKE_BUILD_TYPE=Release \
+	  -DAPP_VERSION=$(DEB_VERSION) -DVERSION=$(DEB_VERSION) LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
+
+override_dh_missing:
+	dh_missing --fail-missing

## deepin-calculator 5.7.12

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,8 @@
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})
 
+ADD_COMPILE_OPTIONS(-fno-access-control)
+
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_AUTOMOC ON)
@@ -18,7 +20,7 @@
 set(QT_MINIMUM_VERSION "5.7.1")
 set(CMAKE_EXE_LINKER_FLAGS "-pie")
 
-add_definitions(-DQT_NO_DEBUG_OUTPUT)
+#add_definitions(-DQT_NO_DEBUG_OUTPUT)
 
 if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
@@ -78,37 +80,38 @@
 SET(HEAD ${CMAKE_CURRENT_LIST_DIR}/../src
          ${CMAKE_CURRENT_LIST_DIR}/../src/bak
          ${CMAKE_CURRENT_LIST_DIR}/../src/control
-         ${CMAKE_CURRENT_LIST_DIR}/../src/core
-         ${CMAKE_CURRENT_LIST_DIR}/../src/math
+         ${CMAKE_CURRENT_LIST_DIR}/../3rdparty/core
+         ${CMAKE_CURRENT_LIST_DIR}/../3rdparty/math
          ${CMAKE_CURRENT_LIST_DIR}/../src/views
          ${CMAKE_CURRENT_LIST_DIR}/../src/widgets
          )
 
 file(GLOB_RECURSE CAL_H ${CMAKE_CURRENT_LIST_DIR}/../src/*.h)
+file(GLOB_RECURSE CAL_C ${CMAKE_CURRENT_LIST_DIR}/../src/*.c)
+file(GLOB_RECURSE CAL_CPP ${CMAKE_CURRENT_LIST_DIR}/../src/*.cpp)
+file(GLOB_RECURSE CAL_3rdH ${CMAKE_CURRENT_LIST_DIR}/../3rdparty/*.h)
+file(GLOB_RECURSE CAL_3rdC ${CMAKE_CURRENT_LIST_DIR}/../3rdparty/*.c)
+file(GLOB_RECURSE CAL_3rdCPP ${CMAKE_CURRENT_LIST_DIR}/../3rdparty/*.cpp)
+list(REMOVE_ITEM CAL_CPP "${CMAKE_CURRENT_LIST_DIR}/../src/main.cpp")
 
-file(GLOB_RECURSE CAL_C ${CMAKE_CURRENT_LIST_DIR}/../src/*.c)
-
-file(GLOB_RECURSE CAL_CPP ${CMAKE_CURRENT_LIST_DIR}/../src/*.cpp)
-list(REMOVE_ITEM CAL_CPP "${CMAKE_CURRENT_LIST_DIR}/../src/main.cpp")
 file(GLOB_RECURSE CAL_TEST ${CMAKE_CURRENT_LIST_DIR}/src/*.cpp)
 file(GLOB_RECURSE CAL_TESTH ${CMAKE_CURRENT_LIST_DIR}/src/*.h)
-include_directories(third_party)                           #一下三行添加包含以便测试用例代码的编写
-include_directories(third_party/googlemock/include)
-include_directories(third_party/googletest/include)
-add_subdirectory(third_party)                              #添加googletest库
+
+find_package(GTest REQUIRED)
+include_directories(${GTEST_INCLUDE_DIRS})
 
 set (DC_QRC_FILES
     ${CMAKE_CURRENT_LIST_DIR}/../src/deepin-calculator.qrc
 )
 
 set(PROJECT_NAME_TEST
-    ${PROJECT_NAME}_test)
+    ${PROJECT_NAME}-test)
 
 # 生成测试可执行程序
-add_executable(${PROJECT_NAME_TEST} ${CAL_H} ${CAL_C} ${CAL_CPP} ${CAL_TEST} ${CAL_TESTH})
+add_executable(${PROJECT_NAME_TEST} ${CAL_H} ${CAL_C} ${CAL_CPP} ${CAL_3rdH} ${CAL_3rdC} ${CAL_3rdCPP} ${CAL_TEST} ${CAL_TESTH})
 
 # 生成测试可执行程序的依赖库
-target_link_libraries(${PROJECT_NAME_TEST} gmock gmock_main gtest gtest_main)
+target_link_libraries(${PROJECT_NAME_TEST} ${GTEST_LIBRARYS} ${GTEST_MAIN_LIBRARYS} gmock gmock_main gtest gtest_main pthread)
 
 target_include_directories(${PROJECT_NAME_TEST} PUBLIC ${Qt5Widgets_LIBRARIES}
                                               ${Qt5DBus_LIBRARIES}
@@ -118,6 +121,7 @@
                                               ${DtkCore_LIBRARIES}
                                               ${DtkGUI_INCLUDE_DIRS}
                                               ${DFrameworkDBus_INCLUDE_DIRS}
+                                              ${GTEST_INCLUDE_DIRS}
                                               ${HEAD})
 target_link_libraries (${PROJECT_NAME_TEST} ${LINK_LIBS})
 
@@ -131,37 +135,40 @@
 install(FILES ${CMAKE_CURRENT_LIST_DIR}/../src/assets/images/deepin-calculator.svg
             DESTINATION share/icons/hicolor/scalable/apps/)
 
+
 #------------------------------ 创建'make test'指令---------------------------------------
 add_custom_target(test
-    COMMAND mkdir -p tests/coverageResult
-    WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
+#    COMMAND mkdir -p tests/coverageResult
+#    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
+)
 
 add_custom_command(TARGET test
     COMMAND echo " =================== CREAT LCOV REPROT BEGIN ==================== "
 
     #1.清理原先的gcov信息
-    COMMAND lcov --directory ./tests/CMakeFiles/${PROJECT_NAME_TEST}.dir --zerocounters
-    COMMAND lcov --directory ./tests/CMakeFiles/${PROJECT_NAME}.dir --zerocounters
-    COMMAND ./tests/${PROJECT_NAME_TEST}
+#    COMMAND lcov --directory ./tests/CMakeFiles/${PROJECT_NAME_TEST}.dir --zerocounters
+#    COMMAND lcov --directory ./tests/CMakeFiles/${PROJECT_NAME}.dir --zerocounters
+    COMMAND ${CMAKE_BINARY_DIR}/tests/${PROJECT_NAME_TEST}
+
 
     #2.收集gcov信息到.info文件中
-    COMMAND lcov --directory . --capture --output-file ./tests/coverageResult/${PROJECT_NAME}_Coverage.info
+#    COMMAND lcov --directory . --capture --output-file ./tests/coverageResult/${PROJECT_NAME}_Coverage.info
 
     #3.过滤一些我们不感兴趣的文件的覆盖率信息
-    COMMAND echo " =================== do filter begin ==================== "
-    COMMAND lcov --remove ./tests/coverageResult/${PROJECT_NAME}_Coverage.info
-    '*/${PROJECT_NAME_TEST}_autogen/*' '*/${PROJECT_NAME}_autogen/*' '*/tests/*' '*/googletest/*' '*/usr/include/*' '*/src/bak/*' '*/src/core/*' '*/src/math/*'
-    -o ./tests/coverageResult/${PROJECT_NAME}_Coverage.info
-    COMMAND echo " =================== do filter end ==================== "
+#    COMMAND echo " =================== do filter begin ==================== "
+#    COMMAND lcov --remove ./tests/coverageResult/${PROJECT_NAME}_Coverage.info
+#    '*/${PROJECT_NAME_TEST}_autogen/*' '*/${PROJECT_NAME}_autogen/*' '*/tests/*' '*/googletest/*' '*/usr/include/*' '*/src/bak/*' '*/src/core/*' '*/src/math/*'
+#    -o ./tests/coverageResult/${PROJECT_NAME}_Coverage.info
+#    COMMAND echo " =================== do filter end ==================== "
 
     #3.将.info信息生成报告到reprot文件夹中
-    COMMAND genhtml -o ./tests/coverageResult/report ./tests/coverageResult/${PROJECT_NAME}_Coverage.info
+#    COMMAND genhtml -o ./tests/coverageResult/report ./coverageResult/${PROJECT_NAME}_Coverage.info
 
     COMMAND echo " =================== CREAT LCOV REPROT END ==================== "
 
-    COMMAND echo " Coverage files have been output to ${CMAKE_BINARY_DIR}/coverageResult/report "
+#    COMMAND echo " Coverage files have been output to ${CMAKE_BINARY_DIR}/coverageResult/report "
 
-    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
+#    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
     )
 
 #'make test'命令依赖与我们的测试程序
@@ -169,3 +176,13 @@
 
 # 设置添加gocv相关信息的输出
 set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
+set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
+if(CMAKE_SAFETYTEST STREQUAL "")
+    set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
+endif()
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D${CMAKE_SAFETYTEST}")
+if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_ON")
+  #安全测试选项
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
+endif()

=== debian/changelog ===
deepin-calculator (5.7.12-3) unstable; urgency=medium

  * debian/rules: skip dh_auto_test for ftbfs archs.

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Wed, 16 Mar 2022 13:36:43 +0545

deepin-calculator (5.7.12-2) unstable; urgency=medium

  * debian/patches: fix ftbfs in buildds due to failed test.

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Tue, 15 Mar 2022 02:27:32 +0545

deepin-calculator (5.7.12-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

  [ Arun Kumar Pariyar ]
  * New upstream release 5.7.12.
  * debian/rules: Enable bindnow hardening flag.
  * debian/copyright: Update copyright information.
  * debian/control:
    + Bump Standards-Version to 4.6.0.
    + Update build dependencies.

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Thu, 10 Mar 2022 19:20:24 +0545

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1
include /usr/share/dpkg/pkg-info.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CPPFLAGS_MAINT_APPEND = -Wl,-z,now

export QT_SELECT := 5

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_BUILD_TYPE=Release \
	  -DAPP_VERSION=$(DEB_VERSION) -DVERSION=$(DEB_VERSION) LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

ifeq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 i386))
override_dh_auto_test:

endif

override_dh_missing:
	dh_missing --fail-missing

## deepin-calculator 5.7.16

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9.5)

if (NOT DEFINED VERSION)
    set(VERSION 1.2.2)
endif ()

#最外层一个工程，单项目中不添加工程，只添加执行文件
project(deepin-calculator)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-needed -fPIE")
set(QT_MINIMUM_VERSION "5.7.1")
set(CMAKE_EXE_LINKER_FLAGS "-pie")

#add_definitions(-DQT_NO_DEBUG_OUTPUT)

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    message(STATUS "this system is mips64=========")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -Wl,--as-needed")
endif()

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")

    execute_process(COMMAND bash "${CMAKE_CURRENT_LIST_DIR}/translate_generation.sh"
                    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/)
endif ()

set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
if(CMAKE_SAFETYTEST STREQUAL "")
    set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D${CMAKE_SAFETYTEST}")
if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_ON")
  #安全测试选项
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
endif()

configure_file(src/environments.h.in environments.h @ONLY)

# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Xml REQUIRED)
find_package(Qt5Svg REQUIRED)
find_package(Qt5Test REQUIRED)

find_package(DtkWidget REQUIRED dtkwidget)
find_package(DtkGui REQUIRED dtkgui)
find_package(DtkCore REQUIRED dtkcore)
#find_package(DFrameworkDbus REQUIRED dframeworkdbus)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

include_directories(${DtkWidget_INCLUDE_DIRS})
include_directories(${DtkGui_INCLUDE_DIRS})
include_directories(${DtkCore_INCLUDE_DIRS})

set (EXE_NAME deepin-calculator)

set(LINK_LIBS
    Qt5::Core
    Qt5::DBus
    Qt5::Widgets
    Qt5::Xml
    Qt5::Svg
    Qt5::Test

    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
)

file(GLOB_RECURSE CAL_SRCH ${CMAKE_CURRENT_LIST_DIR}/src/*.h)
file(GLOB_RECURSE CAL_SRCC ${CMAKE_CURRENT_LIST_DIR}/src/*.c)
file(GLOB_RECURSE CAL_SRCCPP ${CMAKE_CURRENT_LIST_DIR}/src/*.cpp)
file(GLOB_RECURSE CAL_3rdH ${CMAKE_CURRENT_LIST_DIR}/3rdparty/*.h)
file(GLOB_RECURSE CAL_3rdC ${CMAKE_CURRENT_LIST_DIR}/3rdparty/*.c)
file(GLOB_RECURSE CAL_3rdCPP ${CMAKE_CURRENT_LIST_DIR}/3rdparty/*.cpp)

set (DC_QRC_FILES
    src/deepin-calculator.qrc
)

add_executable (${EXE_NAME}
    ${CAL_SRCH}
    ${CAL_SRCC}
    ${CAL_SRCCPP}
    ${CAL_3rdH}
    ${CAL_3rdC}
    ${CAL_3rdCPP}
    ${DC_QRC_FILES}
)

target_include_directories(${EXE_NAME} PUBLIC ${Qt5Widgets_LIBRARIES}
                                              ${Qt5DBus_LIBRARIES}
                                              ${Qt5TestLib_LIBRARIES}
                                              ${PROJECT_BINARY_DIR}
                                              ${DtkWidget_INCLUDE_DIRS}
                                              ${DtkCore_LIBRARIES}
                                              ${DtkGUI_INCLUDE_DIRS}
                                              ${DFrameworkDBus_INCLUDE_DIRS})

target_link_libraries (${EXE_NAME} ${LINK_LIBS})

set(CMAKE_INSTALL_PREFIX /usr)

install(TARGETS deepin-calculator DESTINATION bin)
file(GLOB QM_FILES "${CMAKE_CURRENT_LIST_DIR}/translations/*.qm")
install(FILES ${QM_FILES} DESTINATION share/deepin-calculator/translations)
install(FILES ${CMAKE_CURRENT_LIST_DIR}/deepin-calculator.desktop
        DESTINATION share/applications/)
install(FILES ${CMAKE_CURRENT_LIST_DIR}/src/assets/images/deepin-calculator.svg
            DESTINATION share/icons/hicolor/scalable/apps/)
install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/src/assets/deepin-calculator
                DESTINATION /usr/share/deepin-manual/manual-assets/application/)

#if (NOT ${CMAKE_SYSTEM_PROCESSOR} MATCHES "loongarch64")
add_subdirectory(tests)  #tests为ut测试文件夹名
#endif ()

=== debian/changelog ===
deepin-calculator (5.7.16-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 26 Jan 2022 09:16:36 +0800

deepin-calculator (0.1-1) unstable; urgency=medium

  * Initial Release.

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 11 Oct 2017 17:38:35 +0800

## deepin-calculator 5.7.20

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -175,7 +175,7 @@
 add_dependencies(test ${PROJECT_NAME_TEST})
 
 # 设置添加gocv相关信息的输出
-set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
+#set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
 set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
 if(CMAKE_SAFETYTEST STREQUAL "")
     set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
@@ -186,3 +186,9 @@
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
 endif()
+
+#代码覆盖率开关
+if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
+endif()

=== debian/changelog ===
deepin-calculator (5.7.20-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 16 May 2022 10:23:00 +0800

## deepin-calculator 5.7.21

=== CMakeLists.txt ===
--- 
+++ 
@@ -131,3 +131,10 @@
 #if (NOT ${CMAKE_SYSTEM_PROCESSOR} MATCHES "loongarch64")
 add_subdirectory(tests)  #tests为ut测试文件夹名
 #endif ()
+
+
+#代码覆盖率开关
+if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
+endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -175,7 +175,7 @@
 add_dependencies(test ${PROJECT_NAME_TEST})
 
 # 设置添加gocv相关信息的输出
-#set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
+set(CMAKE_CXX_FLAGS "-g -fprofile-arcs -ftest-coverage")
 set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
 if(CMAKE_SAFETYTEST STREQUAL "")
     set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
@@ -187,8 +187,3 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
 endif()
 
-#代码覆盖率开关
-if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
-  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
-endif()

=== debian/changelog ===
deepin-calculator (5.7.21-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:44:17 +1100

deepin-calculator (5.7.21-2build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:11:50 +0000

deepin-calculator (5.7.21-2) unstable; urgency=medium

  * debian/patches: Fix ftbfs by removing
    explicit cxx11. (Closes: #1041080)
  * debian/control:
    + Bump standard version to 4.6.2.
    + Add myself to uploaders list.

 -- Nisha Pariyar <nishapariyar48@gmail.com>  Wed, 19 Jul 2023 00:58:39 +0545

deepin-calculator (5.7.21-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.

  [ Boyuan Yang ]
  * New upstream release.
  * debian/patches/0002: Add patch to avoid CMAKE_CXX_FLAGS override.

 -- Boyuan Yang <byang@debian.org>  Wed, 13 Jul 2022 16:06:31 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: deepin-calculator
 Section: math
 Priority: optional
-Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
 Uploaders:
  Yangfl <mmyangfl@gmail.com>,
  Yanhao Mo <yanhaocs@gmail.com>,
@@ -10,18 +11,22 @@
  Tu Qinggang <tuqinggang@uniontech.com>,
  Clay Stan <claystan97@gmail.com>,
  qinxialei <xialeiqin@gmail.com>,
+ Nisha Pariyar <nishapariyar48@gmail.com>,
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
+ lcov,
+ libdframeworkdbus-dev,
  libdtkgui-dev,
  libdtkwidget-dev,
+ libgmock-dev,
+ libgtest-dev,
  libqt5svg5-dev,
  pkg-config,
+ qtbase5-dev,
  qttools5-dev-tools,
- qtbase5-dev,
- libdframeworkdbus-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/linuxdeepin/deepin-calculator
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-calculator.git
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-calculator

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%deepin-calculator-$1.tar.gz%" \
   https://github.com/linuxdeepin/deepin-calculator/tags \
   (?:.*?/)?(\d[\d.]*)\.tar\.gz debian uupdate

## deepin-calculator 5.7.22

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,8 @@
 
 #最外层一个工程，单项目中不添加工程，只添加执行文件
 project(deepin-calculator)
+
+include(GNUInstallDirs)
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})
 
@@ -49,19 +51,11 @@
 configure_file(src/environments.h.in environments.h @ONLY)
 
 # Find the library
+find_package(Qt5 REQUIRED Core Gui Widgets DBus Xml Svg Test)
 find_package(PkgConfig REQUIRED)
-find_package(Qt5Widgets REQUIRED)
-find_package(Qt5Core REQUIRED)
-find_package(Qt5Gui REQUIRED)
-find_package(Qt5DBus REQUIRED)
-find_package(Qt5Xml REQUIRED)
-find_package(Qt5Svg REQUIRED)
-find_package(Qt5Test REQUIRED)
-
-find_package(DtkWidget REQUIRED dtkwidget)
-find_package(DtkGui REQUIRED dtkgui)
-find_package(DtkCore REQUIRED dtkcore)
-#find_package(DFrameworkDbus REQUIRED dframeworkdbus)
+pkg_check_modules(DtkWidget REQUIRED dtkwidget)
+pkg_check_modules(DtkGui REQUIRED dtkgui)
+pkg_check_modules(DtkCore REQUIRED dtkcore)
 pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
 
 include_directories(${DtkWidget_INCLUDE_DIRS})
@@ -116,20 +110,25 @@
 
 target_link_libraries (${EXE_NAME} ${LINK_LIBS})
 
-set(CMAKE_INSTALL_PREFIX /usr)
+if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
+    set(CMAKE_INSTALL_PREFIX /usr)
+endif ()
 
-install(TARGETS deepin-calculator DESTINATION bin)
+install(TARGETS deepin-calculator DESTINATION ${CMAKE_INSTALL_BINDIR})
 file(GLOB QM_FILES "${CMAKE_CURRENT_LIST_DIR}/translations/*.qm")
-install(FILES ${QM_FILES} DESTINATION share/deepin-calculator/translations)
+install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-calculator/translations)
 install(FILES ${CMAKE_CURRENT_LIST_DIR}/deepin-calculator.desktop
-        DESTINATION share/applications/)
+        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications/)
 install(FILES ${CMAKE_CURRENT_LIST_DIR}/src/assets/images/deepin-calculator.svg
-            DESTINATION share/icons/hicolor/scalable/apps/)
+            DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps/)
 install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/src/assets/deepin-calculator
-                DESTINATION /usr/share/deepin-manual/manual-assets/application/)
+                DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-manual/manual-assets/application/)
 
 #if (NOT ${CMAKE_SYSTEM_PROCESSOR} MATCHES "loongarch64")
+option (BUILD_TESTING "" ON)
+if (BUILD_TESTING)
 add_subdirectory(tests)  #tests为ut测试文件夹名
+endif ()
 #endif ()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
 #源程序cmakelists再添加上ut相关环境搭建
 #ut相关环境搭建详情见
 #https://wikidev.uniontech.com/index.php?title=UT_%E6%B5%8B%E8%AF%95%E7%8E%AF%E5%A2%83%E6%90%AD%E5%BB%BA#.E7.94.A8.E4.BE.8B.E7.BC.96.E5.86.99_.7C_UT_Case
@@ -41,19 +45,11 @@
 configure_file(${CMAKE_CURRENT_LIST_DIR}/../src/environments.h.in environments.h @ONLY)
 
 # Find the library
+find_package(Qt5 REQUIRED Core Gui Widgets DBus Xml Svg Test)
 find_package(PkgConfig REQUIRED)
-find_package(Qt5Widgets REQUIRED)
-find_package(Qt5Core REQUIRED)
-find_package(Qt5Gui REQUIRED)
-find_package(Qt5DBus REQUIRED)
-find_package(Qt5Xml REQUIRED)
-find_package(Qt5Svg REQUIRED)
-find_package(Qt5Test REQUIRED)
-
-find_package(DtkWidget REQUIRED dtkwidget)
-find_package(DtkGui REQUIRED dtkgui)
-find_package(DtkCore REQUIRED dtkcore)
-#find_package(DFrameworkDbus REQUIRED dframeworkdbus)
+pkg_check_modules(DtkWidget REQUIRED dtkwidget)
+pkg_check_modules(DtkGui REQUIRED dtkgui)
+pkg_check_modules(DtkCore REQUIRED dtkcore)
 pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
 
 include_directories(${DtkWidget_INCLUDE_DIRS})

=== debian/changelog ===
deepin-calculator (5.7.22-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 17 Nov 2022 10:39:21 +0800

deepin-calculator (1.0.0) unstable; urgency=medium

  * New version 1.0.0.

 -- xiepengfei <xiepengfei@uniontech.com>  Thur, 14 Jul 2022 14:27:00 +0800

=== debian/control ===
Source: deepin-calculator
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.org>
Build-Depends: debhelper (>= 9),cmake ,pkg-config, libdtkgui-dev, libdtkwidget-dev, libqt5svg5-dev, qttools5-dev-tools, libdframeworkdbus-dev, libgtest-dev, libgmock-dev
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

Package: deepin-calculator
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: uos-reporter, deepin-event-log
Description: Calculator for UOS
 Calculator is a simple and easy-to-use desktop calculator. It supports addition, subtraction, multiplication and division with keyboard input perfectly matched, as well as symbolic fault-tolerant computing and calculation result linkage.

## deepin-calculator 6.0.1

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -45,16 +45,27 @@
 configure_file(${CMAKE_CURRENT_LIST_DIR}/../src/environments.h.in environments.h @ONLY)
 
 # Find the library
-find_package(Qt5 REQUIRED Core Gui Widgets DBus Xml Svg Test)
 find_package(PkgConfig REQUIRED)
-pkg_check_modules(DtkWidget REQUIRED dtkwidget)
-pkg_check_modules(DtkGui REQUIRED dtkgui)
-pkg_check_modules(DtkCore REQUIRED dtkcore)
-pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
+find_package(Qt5Widgets REQUIRED)
+find_package(Qt5Core REQUIRED)
+find_package(Qt5Gui REQUIRED)
+find_package(Qt5DBus REQUIRED)
+find_package(Qt5Xml REQUIRED)
+find_package(Qt5Svg REQUIRED)
+find_package(Qt5Test REQUIRED)
+
+find_package(DtkWidget REQUIRED dtkwidget)
+find_package(DtkGui REQUIRED dtkgui)
+find_package(DtkCore REQUIRED dtkcore)
 
 include_directories(${DtkWidget_INCLUDE_DIRS})
 include_directories(${DtkGui_INCLUDE_DIRS})
 include_directories(${DtkCore_INCLUDE_DIRS})
+
+pkg_check_modules(GTEST REQUIRED
+    gtest
+    gmock
+    )
 
 set (EXE_NAME deepin-calculator)
 
@@ -93,7 +104,7 @@
 file(GLOB_RECURSE CAL_TEST ${CMAKE_CURRENT_LIST_DIR}/src/*.cpp)
 file(GLOB_RECURSE CAL_TESTH ${CMAKE_CURRENT_LIST_DIR}/src/*.h)
 
-find_package(GTest REQUIRED)
+#find_package(GTest REQUIRED)
 include_directories(${GTEST_INCLUDE_DIRS})
 
 set (DC_QRC_FILES
@@ -121,7 +132,12 @@
                                               ${HEAD})
 target_link_libraries (${PROJECT_NAME_TEST} ${LINK_LIBS})
 
-set(CMAKE_INSTALL_PREFIX /usr)
+#set(CMAKE_INSTALL_PREFIX /usr)
+if(DEFINED ENV{PREFIX})
+    set(CMAKE_INSTALL_PREFIX $ENV{PREFIX})
+else()
+    set(CMAKE_INSTALL_PREFIX /usr)
+endif()
 
 install(TARGETS deepin-calculator DESTINATION bin)
 file(GLOB QM_FILES "${CMAKE_CURRENT_LIST_DIR}/../translations/*.qm")

=== debian/changelog ===
deepin-calculator (6.0.1) unstable; urgency=medium

  * fix: project adaptation
  * chore(CI): add OBS workflows
  * fix: 修复了一系列build warning
    Thanks to hongsheng
  * chore: Sync by https://github.com/linuxdeepin/.github/commit/2e5e092ba3f86b16d1aabbabcf0bfd2ae65b19c8(Influence: none)
  * fix: 修复焦点异常问题(Bug: 162597)
  * chore: Sync by https://github.com/linuxdeepin/.github/commit/559e91167d4919644f37bbcf123eb0651c1528ea(Influence: none)
  * chore(CI): Update obs tag build workflow (#106)
    Thanks to hudeng-go
  * Fix: integer overflow in '_setstr' functions.
    Thanks to Like_rm
  * Fix: integer overflow in '_setstr' functions.
    Thanks to Like_rm
  * fix: remove unused dframeworkdbus (#109)
    Thanks to Felix Yan
  * fix: The icon display incorrectly in deepin-manual(Bug: 251243)

 -- myml <wurongjie@deepin.org>  Thu, 18 Apr 2024 17:26:42 +0800

deepin-calculator (6.0.0) unstable; urgency=medium

  * v23 changlog

 -- muyuankai <muyuankai@uniontech.com>  Thu, 05 Jan 2023 10:38:35 +0800

deepin-calculator (5.8.24) unstable; urgency=medium

  * v23 merge.

 -- muyuankai <muyuankai@uniontech.com>  Thu, 29 Dec 2022 10:38:35 +0800

deepin-calculator (5.8.23) unstable; urgency=medium

  * New version 5.8.23.

 -- xiepengfei <xiepengfei@uniontech.com>  Fri, 18 Nov 2022 16:33:00 +0800

## deepin-calculator 6.5.2

=== debian/changelog ===
deepin-calculator (6.5.2-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Fri, 06 Dec 2024 19:31:33 -0500

deepin-calculator (6.0.1-1) unstable; urgency=medium

  * New upstream release.

  [ Raju Devidas ]
  * Update names of authors for different files in d/copyright
  * Added link time optimization flag in d/rules (Closes: #1015382)

 -- Boyuan Yang <byang@debian.org>  Fri, 06 Dec 2024 19:21:34 -0500

=== debian/control ===
Source: deepin-calculator
Section: math
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Yangfl <mmyangfl@gmail.com>,
 Yanhao Mo <yanhaocs@gmail.com>,
 Boyuan Yang <byang@debian.org>,
 Arun Kumar Pariyar <openarungeek@gmail.com>,
 Tu Qinggang <tuqinggang@uniontech.com>,
 Clay Stan <claystan97@gmail.com>,
 qinxialei <xialeiqin@gmail.com>,
 Nisha Pariyar <nishapariyar48@gmail.com>,
 Raju Devidas <mail@raju.dev>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 lcov,
 libdframeworkdbus-dev,
 libdtkgui-dev,
 libdtkwidget-dev,
 libgmock-dev,
 libgtest-dev,
 libqt5svg5-dev,
 pkgconf,
 qtbase5-dev,
 qttools5-dev-tools,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/linuxdeepin/deepin-calculator
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-calculator.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-calculator

Package: deepin-calculator
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Calculator for DDE (Deepin Desktop Environment)
 An easy to use calculator for ordinary users.
 .
 This package is part of DDE (Deepin Desktop Environment).
